<?php
/* Autor...:  */
/* Esquema.: ALM_ItemTipo.xml */
/* Generado: 2020-08-18 04:21:24 */

/* Metodos de acceso a los campos de la tabla ALM_ItemTipo */
abstract class BaseALM_ItemTipoBN
{
    /* Campos de la tabla */
    private $s_IdItemTipo;    // IdItemTipo: ( no definido )
    private $s_DescripcionLocal;    // DescripcionLocal: ( no definido )
    private $s_DescripcionIngles;    // DescripcionIngles: ( no definido )
    private $s_CodigoSunat;    // CodigoSunat: ( no definido )
    private $s_CuentaMayor;    // CuentaMayor: ( no definido )
    private $s_IngenieriaFlag;    // IngenieriaFlag: ( no definido )
    private $s_TransacciondelSistemaFlag;    // TransacciondelSistemaFlag: ( no definido )
    private $s_MateriaPrimaFlag;    // MateriaPrimaFlag: ( no definido )
    private $s_VerDiaSemanaFlag;    // VerDiaSemanaFlag: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )

    /* Establece el valor del campo IdItemTipo */
    public function setIdItemTipo( $s_IdItemTipo )
    {
        $this->s_IdItemTipo = $s_IdItemTipo;
    }

    /* Obtiene el valor del campo IdItemTipo */
    public function getIdItemTipo()
    {
        return $this->s_IdItemTipo;
    }

    /* Establece el valor del campo DescripcionLocal */
    public function setDescripcionLocal( $s_DescripcionLocal )
    {
        $this->s_DescripcionLocal = $s_DescripcionLocal;
    }

    /* Obtiene el valor del campo DescripcionLocal */
    public function getDescripcionLocal()
    {
        return $this->s_DescripcionLocal;
    }

    /* Establece el valor del campo DescripcionIngles */
    public function setDescripcionIngles( $s_DescripcionIngles )
    {
        $this->s_DescripcionIngles = $s_DescripcionIngles;
    }

    /* Obtiene el valor del campo DescripcionIngles */
    public function getDescripcionIngles()
    {
        return $this->s_DescripcionIngles;
    }

    /* Establece el valor del campo CodigoSunat */
    public function setCodigoSunat( $s_CodigoSunat )
    {
        $this->s_CodigoSunat = $s_CodigoSunat;
    }

    /* Obtiene el valor del campo CodigoSunat */
    public function getCodigoSunat()
    {
        return $this->s_CodigoSunat;
    }

    /* Establece el valor del campo CuentaMayor */
    public function setCuentaMayor( $s_CuentaMayor )
    {
        $this->s_CuentaMayor = $s_CuentaMayor;
    }

    /* Obtiene el valor del campo CuentaMayor */
    public function getCuentaMayor()
    {
        return $this->s_CuentaMayor;
    }

    /* Establece el valor del campo IngenieriaFlag */
    public function setIngenieriaFlag( $s_IngenieriaFlag )
    {
        $this->s_IngenieriaFlag = $s_IngenieriaFlag;
    }

    /* Obtiene el valor del campo IngenieriaFlag */
    public function getIngenieriaFlag()
    {
        return $this->s_IngenieriaFlag;
    }

    /* Establece el valor del campo TransacciondelSistemaFlag */
    public function setTransacciondelSistemaFlag( $s_TransacciondelSistemaFlag )
    {
        $this->s_TransacciondelSistemaFlag = $s_TransacciondelSistemaFlag;
    }

    /* Obtiene el valor del campo TransacciondelSistemaFlag */
    public function getTransacciondelSistemaFlag()
    {
        return $this->s_TransacciondelSistemaFlag;
    }

    /* Establece el valor del campo MateriaPrimaFlag */
    public function setMateriaPrimaFlag( $s_MateriaPrimaFlag )
    {
        $this->s_MateriaPrimaFlag = $s_MateriaPrimaFlag;
    }

    /* Obtiene el valor del campo MateriaPrimaFlag */
    public function getMateriaPrimaFlag()
    {
        return $this->s_MateriaPrimaFlag;
    }

    /* Establece el valor del campo VerDiaSemanaFlag */
    public function setVerDiaSemanaFlag( $s_VerDiaSemanaFlag )
    {
        $this->s_VerDiaSemanaFlag = $s_VerDiaSemanaFlag;
    }

    /* Obtiene el valor del campo VerDiaSemanaFlag */
    public function getVerDiaSemanaFlag()
    {
        return $this->s_VerDiaSemanaFlag;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdItemTipo' => $this->getIdItemTipo(),
            'DescripcionLocal' => $this->getDescripcionLocal(),
            'DescripcionIngles' => $this->getDescripcionIngles(),
            'CodigoSunat' => $this->getCodigoSunat(),
            'CuentaMayor' => $this->getCuentaMayor(),
            'IngenieriaFlag' => $this->getIngenieriaFlag(),
            'TransacciondelSistemaFlag' => $this->getTransacciondelSistemaFlag(),
            'MateriaPrimaFlag' => $this->getMateriaPrimaFlag(),
            'VerDiaSemanaFlag' => $this->getVerDiaSemanaFlag(),
            'Estado' => $this->getEstado(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaCreacion' => $this->getFechaCreacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto ALM_ItemTipoBN desde un RecordSet */
    public static function retrieveByRs( $o_ALM_ItemTipoRs )
    {
        $o_ALM_ItemTipoBN = new ALM_ItemTipoBN();
        $o_ALM_ItemTipoBN->setIdItemTipo( $o_ALM_ItemTipoRs[ "IdItemTipo" ] );
        $o_ALM_ItemTipoBN->setDescripcionLocal( $o_ALM_ItemTipoRs[ "DescripcionLocal" ] );
        $o_ALM_ItemTipoBN->setDescripcionIngles( $o_ALM_ItemTipoRs[ "DescripcionIngles" ] );
        $o_ALM_ItemTipoBN->setCodigoSunat( $o_ALM_ItemTipoRs[ "CodigoSunat" ] );
        $o_ALM_ItemTipoBN->setCuentaMayor( $o_ALM_ItemTipoRs[ "CuentaMayor" ] );
        $o_ALM_ItemTipoBN->setIngenieriaFlag( $o_ALM_ItemTipoRs[ "IngenieriaFlag" ] );
        $o_ALM_ItemTipoBN->setTransacciondelSistemaFlag( $o_ALM_ItemTipoRs[ "TransacciondelSistemaFlag" ] );
        $o_ALM_ItemTipoBN->setMateriaPrimaFlag( $o_ALM_ItemTipoRs[ "MateriaPrimaFlag" ] );
        $o_ALM_ItemTipoBN->setVerDiaSemanaFlag( $o_ALM_ItemTipoRs[ "VerDiaSemanaFlag" ] );
        $o_ALM_ItemTipoBN->setEstado( $o_ALM_ItemTipoRs[ "Estado" ] );
        $o_ALM_ItemTipoBN->setUsuarioModificacion( $o_ALM_ItemTipoRs[ "UsuarioModificacion" ] );
        $o_ALM_ItemTipoBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_ALM_ItemTipoRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_ALM_ItemTipoBN->setUsuarioCreacion( $o_ALM_ItemTipoRs[ "UsuarioCreacion" ] );
        $o_ALM_ItemTipoBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_ALM_ItemTipoRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        return $o_ALM_ItemTipoBN;
    }
}
?>